unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, StdCtrls,
  VirtualTrees;

type

  { TForm1 }

  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    StatusBar1: TStatusBar;
    VirtualStringTree1: TVirtualStringTree;
    procedure CheckBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure VirtualStringTree1Click(Sender: TObject);
    procedure VirtualStringTree1GetText(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: String);
    procedure VirtualStringTree1Resize(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  VirtualStringTree1.RootNodeCount := 20;
  CheckBox1.Checked := hoVisible in VirtualStringTree1.Header.Options;
end;

procedure TForm1.CheckBox1Change(Sender: TObject);
begin
  if TCheckBox(Sender).Checked then
     VirtualStringTree1.Header.Options := VirtualStringTree1.Header.Options + [hoVisible]
  else
    VirtualStringTree1.Header.Options := VirtualStringTree1.Header.Options - [hoVisible]
end;

procedure TForm1.VirtualStringTree1Click(Sender: TObject);

var
  n:PVirtualNode;

begin
  with TVirtualStringTree(Sender) do
  begin
  n := FocusedNode;
  if assigned(n) then
     Application.MessageBox(PChar(Format('Hit Node: %d',[AbsoluteIndex(n)])),'Click!');
  end;
end;

procedure TForm1.VirtualStringTree1GetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: String);
begin
  CellText := FOrmat('Node: %d',[TVirtualStringTree(Sender).AbsoluteIndex(Node)])
end;

procedure TForm1.VirtualStringTree1Resize(Sender: TObject);
begin
  StatusBar1.SimpleText := Format('Tree size: %d x %d',[TVirtualStringTree(Sender).height,TVirtualStringTree(Sender).width]);;
end;

end.

